'''
created on 20 01 2020
greetings from The Flying Dutchan & The Last Drakkar guys
this script gets signature RSA1024 keys from all Conax cards
'''
import serial, sys, os
from time import sleep
from datetime import datetime
from gmpy2 import gcd,mpz,powmod

inversja=False
port_com='COM4'
port_baudrate=9600

exponent_hex='010001'

try:
    os.stat('Logs')
except:
    os.mkdir('Logs')

def inv_HexData(hex_data, isNeeded):
    if isNeeded :
        inv_data='F7B3D591E6A2C480'
        result=str()
        for h_char in hex_data :
            result=result+inv_data[int(h_char, 16)]
        return ''.join([ result[x:x+2][::-1] for x in range(0, len(result), 2) ])
    else :
        return hex_data

def progress(count, total, suffix=''):
    bar_len = 60
    filled_len = int(round(bar_len * count / float(total)))

    percents = round(100.0 * count / float(total), 1)
    bar = '#' * filled_len + '-' * (bar_len - filled_len)

    sys.stdout.write('[%s] %s%s %s\r' % (bar, percents, '%', suffix))
    sys.stdout.flush()  # As suggested by Rom Ruben

def send_serial(sData,w_buff,t_out):
    ser.write((inv_HexData(sData,inversja)).decode('hex'))
    i=0
    print ('Send : '+sData)
    while (ser.in_waiting<w_buff) and (i<t_out) :
        sleep(0.02)
        i=i+20
    sleep(0.05)
    ret=inv_HexData(ser.read(size=ser.in_waiting).encode('hex'),inversja).upper()
    print ('Get : '+ret)
    return ret


ser=serial.Serial(port=port_com,baudrate = port_baudrate, bytesize=8, parity='E', stopbits=2, timeout=1.5, xonxoff=False, rtscts=False, dsrdtr=False)
ser.setRTS(True)
ser.setRTS(False)
sleep(1)
wynik = ser.read(size=ser.in_waiting)

print ('ATR : '+inv_HexData(wynik.encode('hex').upper(),inversja))
#outfile.write('ATR: '+inv_HexData(wynik.encode('hex').upper(),inversja)+'\n')
#outfile.write(str(datetime.now())[:-3]+'\n')

#odczyt seriala conax

send_serial('DD26000003', 6, 1000)

data_tmp=send_serial('100140', 5, 1000)
data_tmp=send_serial('DDCA0000'+data_tmp[-2:], int(data_tmp[-2:], 16)+8, 1000)
send_serial('DD82000014', 6, 1000)
data_tmp=send_serial('1112FFFFFFFFFFFFFFFF0904'+data_tmp[22:26]+'FFFFFFFFFFFF', 0x14+2, 1000)
data_tmp=send_serial('DDCA0000'+data_tmp[-2:], int(data_tmp[-2:], 16)+3, 1000)
serial=data_tmp[data_tmp.index('FFFF2307')+12:data_tmp.index('FFFF2307')+22]
sa=data_tmp[data_tmp.index(serial)+20:-4]
print ('Serial : '+serial)
print ('SA : '+sa)
#send_serial('DDC200000E', 6, 1000)
#data_tmp=send_serial('600CFFFFFFFF3030303031323334', 0x0e+2, 1000)
send_serial('DDC2000024', 6, 1000)
data_tmp=send_serial('612201FFFFFFFF5015010000000000000000000000000000000000000000540431323334', 0x24+2, 1000)

if data_tmp[-4:]=='9031' :
    send_serial('DDC200000E', 6, 1000)
    data_tmp=send_serial('600CFFFFFFFF3030303031323334', 0x0e+2, 1000)
    send_serial('DDC2000024', 6, 1000)
    data_tmp=send_serial('612201FFFFFFFF5015010000000000000000000000000000000000000000540431323334', 0x24+2, 1500)

if data_tmp[-4:-2]=='98' :
    z0tmp=send_serial('DDCA0000'+data_tmp[-2:], int(data_tmp[-2:], 16)+3, 1500)
    z0tmp=z0tmp[22:-4]
    #print ('Z0 : '+z0tmp)
    send_serial('DDC2000024', 6, 1000)
    #data_tmp=send_serial('612201FFFFFFFF5015010000000000000000000000000000000000000001540431323334', 0x24+2, 1500)
    data_tmp=send_serial('612201FFFFFFFF5015019999999999999999999999999999999999999999540431323334', 0x24+2, 1500)
    z1tmp=send_serial('DDCA0000'+data_tmp[-2:], int(data_tmp[-2:], 16)+3, 1500)
    z1tmp=z1tmp[22:-4]
    #print ('Z1 : '+z1tmp)
    send_serial('DDC2000024', 6, 1000)
    #data_tmp=send_serial('612201FFFFFFFF5015010000000000000000000000000000000000000002540431323334', 0x24+2, 1500)
    data_tmp=send_serial('612201FFFFFFFF501501FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF540431323334', 0x24+2, 1500)
    z2tmp=send_serial('DDCA0000'+data_tmp[-2:], int(data_tmp[-2:], 16)+3, 1500)
    z2tmp=z2tmp[22:-4]
    #print ('Z2 : '+z2tmp)
    send_serial('DDC2000024', 6, 1000)
    data_tmp=send_serial('612201FFFFFFFF5015010A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A540431323334', 0x24+2, 1500)
    z3tmp=send_serial('DDCA0000'+data_tmp[-2:], int(data_tmp[-2:], 16)+3, 1500)
    z3tmp=z3tmp[22:-4]
    #print ('Z3 : '+z3tmp)
    send_serial('DDC2000024', 6, 1000)
    data_tmp=send_serial('612201FFFFFFFF5015011313131313131313131313131313131313131313540431323334', 0x24+2, 1500)
    z4tmp=send_serial('DDCA0000'+data_tmp[-2:], int(data_tmp[-2:], 16)+3, 1500)
    z4tmp=z4tmp[22:-4]
    #print ('Z4 : '+z4tmp)
ser.close()


z0a=int('0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003021300906052B0E03021A050004140000000000000000000000000000000000000000',16)
z0b=int(z0tmp, 16)
z0c=int(exponent_hex,16)
#z1a=int('0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003021300906052B0E03021A050004140000000000000000000000000000000000000001',16)
z1a=int('0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003021300906052B0E03021A050004149999999999999999999999999999999999999999',16)
z1b=int(z1tmp, 16)
z1c=int(exponent_hex,16)
#z2a=int('0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003021300906052B0E03021A050004140000000000000000000000000000000000000002',16)
z2a=int('0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003021300906052B0E03021A05000414FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF',16)
z2b=int(z2tmp, 16)
z2c=int(exponent_hex,16)

z3a=int('0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003021300906052B0E03021A050004140A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A',16)
z3b=int(z3tmp, 16)
z3c=int(exponent_hex,16)

z4a=int('0001FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF003021300906052B0E03021A050004141313131313131313131313131313131313131313',16)
z4b=int(z4tmp, 16)
z4c=int(exponent_hex,16)

print ('gcd 1 and 2 = gcd(Z0,Z1,Z2):')
start=datetime.now()
gcd_result=gcd(gcd((z0a-pow(mpz(z0b),z0c)),(z1a-pow(mpz(z1b),z1c))),(z2a-pow(mpz(z2b),z2c)))
gcd_result_hex=hex(gcd_result)
print gcd_result_hex[2:].upper()
print ('calc time: '+str(datetime.now()-start))

N_correct=False

if powmod(z4b,int(exponent_hex,16),gcd_result)==z4a :
    N_correct=True
else :
    print ('N not correct calculate gcd 3 = gcd(gcd2,Z3):')
    start=datetime.now()
    gcd_result=gcd(gcd_result,(z3a-pow(mpz(z3b),z3c)))
    gcd_result_hex=hex(gcd_result)
    print gcd_result_hex[2:].upper()
    print ('calc time: '+str(datetime.now()-start))
    if powmod(z4b,int(exponent_hex,16),gcd_result)==z4a :
        N_correct=True
    else:
        print ('N not correct calculate gcd 4 = gcd(gcd3,Z4):')
        start=datetime.now()
        gcd_result=gcd(gcd_result,(z4a-pow(mpz(z4b),z4c)))
        gcd_result_hex=hex(gcd_result)
        print gcd_result_hex[2:].upper()
        print ('calc time: '+str(datetime.now()-start))
        if powmod(z0b,int(exponent_hex,16),gcd_result)==z0a :
            N_correct=True

if N_correct :
    print ('N Correct')
    file_name='Logs/'+gcd_result_hex[2:].upper()[:32]+'-'+str(int(serial,16)).upper()+'-'+sa.upper()+'-'+datetime.now().strftime("%Y%m%d%H%M%S")+'.txt'
    outfile=open(file_name, 'a')
    outfile.write(gcd_result_hex[2:].upper())
    outfile.close()
    print ('N saved to file: '+file_name)
else:
    print ('NOT Corect N!!!!')
    file_name='Logs/BAD__'+gcd_result_hex[2:].upper()[:32]+'-'+str(int(serial,16)).upper()+'-'+sa.upper()+'-'+datetime.now().strftime("%Y%m%d%H%M%S")+'.txt'
    outfile=open(file_name, 'a')
    outfile.write(gcd_result_hex[2:].upper())
    outfile.close()
    print ('Wrong N saved to file: '+file_name)
#print ('ToUpperCase[IntegerString[(GCD['+str(z0a)+'-('+str(z0b)+'^'+str(z0c)+'),'+str(z1a)+'-('+str(z1b)+'^'+str(z1c)+'),'+str(z2a)+'-('+str(z2b)+'^'+str(z2c)+')]),16]]')
